# Simulation lifecycle

An overview of what methods are invoked in what order
and what they do.

## Initialization

Initialization is everything that has to be set up before
a simulation is run. This includes:
- Generating a population of individuals
- Connecting the individuals in the population according to a network strategy
  - Scale free
  - Small world
  - Ego network
- Initializing the pathogen
- Infecting a patient zero

## Simulation
The simulation lifecycle is as follows:
- Retrieve all pathogens from the population
- Run the `tick` method
  - Increases days_infected field
  - Checks if host dies
  - Checks if the pathogen needs to self terminate
- Get remaining pathogens able to infect
- For each pathogen get the individual and get all connections based on connection weight
- Random number determines if a connection will have contact
- If contact is made, another random number determines if the connection is infected based on infection_rate
- Repeat until we reach a final state
  - Final time step has been reached
  - No more pathogens are able to infect
  - No more individuals are alive

An alternate approach is to save the population at the end of each step and then
copy it over for each subsequent step. Then we do a post-processing step where we 
can convert the whole simulation to digestible data points and then delete the simulation
afterwards. Not sure what I want to do here yet. Allows us to have snapshots of everything
though and can do replays? How large populations do I want to manage this for?

### (GPT-4 rewrite)
1. Retrieve all pathogens from the population
2. Run the `tick` method
   a. Increase days_infected field
   b. Check if host dies
   c. Check if the pathogen needs to self terminate
3. Get remaining pathogens able to infect
4. For each pathogen, get the individual and get all connections based on connection weight
5. Random number determines if a connection will have contact
6. If contact is made, another random number determines if the connection is infected based on infection_rate
7. Save the population state at the end of each step
8. Copy the saved population state for use in the next step
9. Repeat the process until reaching a final state
   a. Final time step has been reached
   b. No more pathogens are able to infect
   c. No more individuals are alive
10. Perform a post-processing step to convert the entire simulation into digestible data points
11. Delete the simulation after extracting the necessary data
