def calculate_pathogen_score(generation):
    # Should doublecheck if these metrics are actually good
    kill_weight = generation.experiment.performance_function_death_weight
    infection_weight = generation.experiment.performance_function_infection_weight
    recovery_weight = generation.experiment.performance_function_recovery_weight

    number_of_kills = generation.number_of_deaths
    number_of_infections = generation.number_of_infections
    number_of_recoveries = generation.number_of_recoveries

    metrics = {
        "kills": number_of_kills,
        "infections": number_of_infections,
        "recoveries": number_of_recoveries,
    }

    score = 0
    for metric, value in metrics.items():
        if metric == "kills":
            score += value * kill_weight
        elif metric == "infections":
            score += value * infection_weight
        elif metric == "recoveries":
            score += value * recovery_weight

    return score
