# Generated by Django 4.1.7 on 2023-05-22 18:08

from django.db import migrations, models
import django.db.models.deletion


class Migration(migrations.Migration):

    initial = True

    dependencies = []

    operations = [
        migrations.CreateModel(
            name="Connection",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("weight", models.FloatField(default=1.0)),
            ],
        ),
        migrations.CreateModel(
            name="Experiment",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("started_at", models.DateTimeField(auto_now_add=True)),
                (
                    "finished_at",
                    models.DateTimeField(blank=True, default=None, null=True),
                ),
                ("label", models.CharField(blank=True, max_length=100, null=True)),
                (
                    "network_topology",
                    models.CharField(
                        choices=[
                            ("Scale Free", "Scale Free"),
                            ("Small World", "Small World"),
                            ("Ego Network", "Ego Network"),
                        ],
                        max_length=100,
                    ),
                ),
                ("population_size", models.IntegerField(default=1000)),
                ("number_of_generations", models.IntegerField(default=10)),
                ("number_of_time_steps", models.IntegerField(default=1000)),
                ("generation_size", models.IntegerField(default=50)),
            ],
        ),
        migrations.CreateModel(
            name="Generation",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("generation_number", models.IntegerField(default=1)),
                ("number_of_infections", models.IntegerField(default=0)),
                ("number_of_deaths", models.IntegerField(default=0)),
                ("number_of_recoveries", models.IntegerField(default=0)),
                ("pathogen_performance_score", models.FloatField(default=0.0)),
            ],
        ),
        migrations.CreateModel(
            name="Pathogen",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("infection_rate_points", models.IntegerField()),
                ("death_rate_points", models.IntegerField()),
                ("mutation_rate_points", models.IntegerField()),
                ("incubation_time_points", models.IntegerField()),
                ("infection_time_points", models.IntegerField()),
                ("immunity_duration_points", models.IntegerField()),
                ("days_infected", models.IntegerField(default=0)),
                ("attack_vector", models.CharField(max_length=10)),
            ],
        ),
        migrations.CreateModel(
            name="Population",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                (
                    "network_topology",
                    models.CharField(
                        choices=[
                            ("Scale Free", "Scale Free"),
                            ("Small World", "Small World"),
                            ("Ego Network", "Ego Network"),
                        ],
                        max_length=100,
                    ),
                ),
            ],
        ),
        migrations.CreateModel(
            name="Individual",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                (
                    "state",
                    models.CharField(
                        choices=[("Alive", "Alive"), ("Dead", "Dead")],
                        default="Alive",
                        max_length=16,
                    ),
                ),
                ("immune_system", models.CharField(max_length=10)),
                (
                    "connections",
                    models.ManyToManyField(
                        blank=True,
                        through="simulations.Connection",
                        to="simulations.individual",
                    ),
                ),
                (
                    "generation",
                    models.ForeignKey(
                        null=True,
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="individuals",
                        to="simulations.generation",
                    ),
                ),
                (
                    "pathogen",
                    models.OneToOneField(
                        blank=True,
                        null=True,
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="individual",
                        to="simulations.pathogen",
                    ),
                ),
            ],
        ),
        migrations.AddField(
            model_name="generation",
            name="base_pathogen",
            field=models.OneToOneField(
                help_text="Base pathogen, used to infect patient zero",
                on_delete=django.db.models.deletion.CASCADE,
                related_name="generation",
                to="simulations.pathogen",
            ),
        ),
        migrations.AddField(
            model_name="generation",
            name="experiment",
            field=models.ForeignKey(
                null=True,
                on_delete=django.db.models.deletion.CASCADE,
                to="simulations.experiment",
            ),
        ),
        migrations.AddField(
            model_name="connection",
            name="connected_individual",
            field=models.ForeignKey(
                on_delete=django.db.models.deletion.CASCADE,
                related_name="connected_individuals",
                to="simulations.individual",
            ),
        ),
        migrations.AddField(
            model_name="connection",
            name="individual",
            field=models.ForeignKey(
                on_delete=django.db.models.deletion.CASCADE,
                related_name="individual_connections",
                to="simulations.individual",
            ),
        ),
    ]
