from django.test import TestCase
from simulations.models import calculate_mitigation_factor


class TestMitigationFactor(TestCase):
    def setUp(self):
        self.mitigation_function = calculate_mitigation_factor

    def test_calculate_mitigation_factor(self):
        # 2/4 overlap
        immune_system = "1111"
        attack_vector = "1100"
        result = self.mitigation_function(immune_system, attack_vector)
        self.assertEqual(result, 0.5, "Test Failed: Expected 0.5")

        # 2/5 overlap
        immune_system = "11111"
        attack_vector = "10001"
        result = self.mitigation_function(immune_system, attack_vector)
        self.assertEqual(result, 0.75, "Test Failed: Expected 0.75")

        # 0 overlap
        immune_system = "1111"
        attack_vector = "0000"
        result = self.mitigation_function(immune_system, attack_vector)
        self.assertEqual(result, 1, "Test Failed: Expected 1")

        # 5/7 overlap
        immune_system = "1111111"
        attack_vector = "1100111"
        result = self.mitigation_function(immune_system, attack_vector)
        self.assertEqual(result, 0.25, "Test Failed: Expected 0.25")

        # 4/4 overlap
        immune_system = "1111"
        attack_vector = "1111"
        result = self.mitigation_function(immune_system, attack_vector)
        self.assertEqual(result, 0, "Test Failed: Expected 0")
